#!/usr/bin/perl -w

# Process the output from unpolluted.py into HTML.
#
# ./unpolluted.py <url> | ./present-html.pl >unpolluted-report.xhtml

use strict;

use XML::Writer;

my $l1 = <>;

my ($url) = ($l1 =~ /URL: (.*)$/);

my $NS = 'http://www.w3.org/1999/xhtml';

my $w = new XML::Writer(NAMESPACES => 1, DATA_MODE => 1,
	PREFIX_MAP => {$NS => ''});

$w->xmlDecl('US-ASCII');

$w->doctype('html', "-//W3C//DTD XHTML 1.1//EN", "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd");

$w->startTag([$NS, 'html']);

$w->startTag([$NS, 'head']);
$w->dataElement([$NS, 'title'], 'Unpolluted report for '.$url);
$w->emptyTag([$NS, 'link'], 'rel' => 'stylesheet', 'type' => 'text/css', 'href' => 'style.css');
$w->endTag([$NS, 'head']);

$w->startTag([$NS, 'body']);

$w->startTag([$NS, 'h1']);
$w->setDataMode(0);
$w->dataElement([$NS, 'a'], 'Unpolluted', 'href' => 'http://www.kafsemo.org/hacks/#unpolluted', 'title' => 'Unpolluted home page');
$w->characters(' report for '.$url);
$w->setDataMode(1);
$w->endTag([$NS, 'h1']);

$w->startTag([$NS, 'table'], 'summary' => 'Status of each test');

while (<>) {
	my ($r, $desc) = /^\[(.*?)\s*\] (.*)$/ or die;

	$w->startTag([$NS, 'tr'], 'class' => lc($r));
	$w->dataElement([$NS, 'td'], $r, 'class' => 'result');
	$w->dataElement([$NS, 'td'], $desc);
	$w->endTag([$NS, 'tr']);
}

$w->endTag([$NS, 'table']);
$w->endTag([$NS, 'body']);
$w->endTag([$NS, 'html']);

$w->end();
